package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.DealerRefereeService;
import com.gxwebsoft.shop.entity.DealerReferee;
import com.gxwebsoft.shop.param.DealerRefereeParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 分销商推荐关系表控制器
 *
 * @author 科技小王子
 * @since 2024-07-28 11:57:41
 */
@Api(tags = "分销商推荐关系表管理")
@RestController
@RequestMapping("/api/shop/dealer-referee")
public class DealerRefereeController extends BaseController {
    @Resource
    private DealerRefereeService dealerRefereeService;

    @ApiOperation("分页查询分销商推荐关系表")
    @GetMapping("/page")
    public ApiResult<PageResult<DealerReferee>> page(DealerRefereeParam param) {
        // 使用关联查询
        return success(dealerRefereeService.pageRel(param));
    }

    @ApiOperation("查询全部分销商推荐关系表")
    @GetMapping()
    public ApiResult<List<DealerReferee>> list(DealerRefereeParam param) {
        // 使用关联查询
        return success(dealerRefereeService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:dealerReferee:list')")
    @ApiOperation("根据id查询分销商推荐关系表")
    @GetMapping("/{id}")
    public ApiResult<DealerReferee> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(dealerRefereeService.getByIdRel(id));
    }

    @ApiOperation("添加分销商推荐关系表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody DealerReferee dealerReferee) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         dealerReferee.setUserId(loginUser.getUserId());
        }
        if (dealerRefereeService.save(dealerReferee)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改分销商推荐关系表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody DealerReferee dealerReferee) {
        if (dealerRefereeService.updateById(dealerReferee)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除分销商推荐关系表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (dealerRefereeService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加分销商推荐关系表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<DealerReferee> list) {
        if (dealerRefereeService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改分销商推荐关系表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<DealerReferee> batchParam) {
        if (batchParam.update(dealerRefereeService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除分销商推荐关系表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (dealerRefereeService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
